//Datei: InitPIC.c
// C-Megert mit PIC16F84
//
// Grundeinstellung des PIC
//
// Copyright 2000 by Holger Klabunde
// 01.05.2001
// Compiler PICC Lite


#include "prozess.h"      /* Der verwendete Prozessor */

#include "cmess.h"
#include "protos.h"

//**************************************************
//**************************************************
//PIC Grundeinstellungen
//**************************************************
//**************************************************
void InitPIC()
{

 CLRWDT();         //Laut Datenblatt vor ndern Prescaler fr TMR0
 OPTION=0b11011000;	 //Prescaler WDT und Intern Clock fr TMR0	
 
// Der Takt des PIC betrgt 10MHz
// Ein Maschinenzyklus damit 400ns

 //TMR0 Interrupt alle 256 * 400ns = 102,4us
 
 TRISA=0b11101; // PortA 	alles Eingnge, auer PA 1
 TRISB=0b01000000; // PortB 	alles Ausgnge auer PB6 

 PORTB=0x40;    //Definierten Zustand einstellen
 PORTA=0b11111;

 INTCON=0b10000000; //Enable Interrupts, TMR0 Interrupt
}
