//Datei: BIN2BCD.C
// Wandelt eine 24 Bit Binrzahl
// in 4 BCD Bytes=>8 Stellen
//
// Nach dem Beispiel von Microchip CD
// Benutzen, nur nicht drber nachdenken !
//
// War auf 16Bit Wert ausgelegt !
// Erweitert auf 24Bit, d.h. bis 16777216 !
// 
// Holger Klabunde
// 01.05.2001
// Compiler PICC Lite

#include "prozess.h"      /* Der verwendete Prozessor */
#include "protos.h"

//Input : 24 Bit Wert in B0=LSB,B1,B2=MSB
//Output: 8 Bit Globale Register  R0,R1,R2,R3
//        R0 = MSB, R3 = LSB
unsigned char B0,B1,B2;
unsigned char R0,R1,R2,R3;
 unsigned char counter,temp;

void BinToBCD24()
{
 
#asm
B2_BCD  bcf _STATUS,0   // clear the carry bit
	movlw 0x18     //24 Bits bearbeiten
	movwf _counter  //Schleifenzhler
	clrf _R0        //R0,R1,R2,R3=0
	clrf _R1
	clrf _R2
	clrf _R3
loop24  rlf _B0     //Rotiere Bitweise mit R3,R2,R1,R0
	rlf _B1
	rlf _B2
	rlf _R3
	rlf _R2
	rlf _R1
	rlf _R0
	decfsz _counter  //Nchstes Bit
	goto adjDEC
	RETLW 0

adjDEC  movlw _R3        //Zeiger auf R3
	movwf _FSR       
	call adjBCD     //BCD-Korrektur
	movlw _R2        //Auch fr R2,R1,R0
	movwf _FSR
	call adjBCD
	movlw _R1       
	movwf _FSR
	call adjBCD
	movlw _R0
	movwf _FSR
	call adjBCD
	goto loop24     //Nchstes von den 24 Bits

	//Register 0 zeigt auf R3,R2,R1 oder R0
adjBCD  movlw 0x03     //Untere BCD-Stelle testen
	addwf 0,W      //0x03 addieren zu R0,R1,R2 oder R3
	movwf _temp     //zwischenspeichern fr Test Bit D3
	btfsc _temp,3   
	movwf 0        

	movlw 0x30     //Das gleiche mit der oberen BCD-Stelle
	addwf 0,W
	movwf _temp
	btfsc _temp,7   
	movwf 0        
	RETLW 0        // Ergebnis in R0,R1,R2,R3 zurckgeben
#endasm
}

//{Zeigt ein BCD-Byte auf der LCD-Anzeige }
//
void ShowBCD(unsigned char x)
{
 //ASCII Zahlen beginnen bei 0x30 => 0
 LCDWriteByte((x>>4)+0x30);  //High-Nibble
 LCDWriteByte((x&0x0F)+0x30);  //Low-Nibble
}

